function res = gotToN(N, i, p)
    % Returns true if the gambler got to N from i (0 <= i <= N), false
    % otherwise.
    % p is probability of winning 1 unit (i.e. getting closer to N by 1.
    % 0 <= p <= 1
    
    if i < 0 || N < 0 || i > N || p < 0 || p > 1
        error('Invalid argument!'); 
    end
    
    if i == 0
        res = false;
        return;
    end
    
    if i == N
       res = true;
       return;
    end
    
    % Start of Simulation
    curIdx = i;
    while true
        if rand < p
           % Success: move ahead by 1
           curIdx = curIdx + 1;
        else
           % Failure: move back by 1
           curIdx = curIdx - 1;
        end
        
        % Check for terminal condition
        if curIdx == N
            res = true;
            return;
        end
        
        if curIdx == 0
            res = false;
            return;
        end
    end
end

